#ifndef YUY2FC_CLIENT_H
#define YUY2FC_CLIENT_H

#define Y2F_VERSION          0x0100
#define Y2F_HEADER_SIZE      0x0020
#define Y2F_OFFSET_VERSION   0x0000
#define Y2F_OFFSET_N_CACHE   0x0004
#define Y2F_OFFSET_WIDTH     0x0008
#define Y2F_OFFSET_HEIGHT    0x000C
#define Y2F_OFFSET_STARTFRM  0x0010
#define Y2F_OFFSET_CACHEPTR  0x0014

static char YUY2FC_MemName[256] = "yuy2fs_";

#define yuy2fc_header(x) (*(int*)(YUY2FC_MemView+(x)))
#define yuy2fc_headerp(x) (*(unsigned char**)(YUY2FC_MemView+(x)))

void* yuy2fc_get_cache(int frame, int w, int h, int *size)
{
  HANDLE YUY2FC_hMemMap;
  unsigned char *YUY2FC_MemView = NULL;
  DWORD pid, temp;
  int n, i, s;
  unsigned char *p;
  
  if(YUY2FC_MemName[7] == 0){
    pid = GetCurrentProcessId();
    for(i = 7; pid >= 10;){
      for(temp = 10; pid / 10 >= temp;) temp *= 10;
      YUY2FC_MemName[i++] = '0' + (char)(pid / temp);
      pid %= temp;
    }
    YUY2FC_MemName[i++] = '0' + (char)pid;
    YUY2FC_MemName[i] = 0;
  }
  
  if(frame < 0) return NULL;
  
  YUY2FC_hMemMap = OpenFileMapping(FILE_MAP_READ, FALSE, YUY2FC_MemName);
  if(YUY2FC_hMemMap == NULL) return NULL;
  YUY2FC_MemView = (unsigned char*) MapViewOfFile(YUY2FC_hMemMap, FILE_MAP_READ, 0, 0, 0);
  if(YUY2FC_MemView == NULL){
    CloseHandle(YUY2FC_hMemMap);
    return NULL;
  }
  
  if(yuy2fc_header(Y2F_OFFSET_VERSION) != Y2F_VERSION ||
     yuy2fc_header(Y2F_OFFSET_WIDTH)   != w ||
     yuy2fc_header(Y2F_OFFSET_HEIGHT)  != h)
    return NULL;
  s = (w >> 1) * 4 * h;
  
  n = -1;
  for(i = 0; i < yuy2fc_header(Y2F_OFFSET_N_CACHE); i++)
    if(yuy2fc_header(Y2F_HEADER_SIZE + i * 4) == yuy2fc_header(Y2F_OFFSET_STARTFRM) + frame)
      n = i;
  
  if(n >= 0){
    p =yuy2fc_headerp(Y2F_OFFSET_CACHEPTR) + s * n;
    *size = s;
  }else
    p = NULL;
  
  UnmapViewOfFile(YUY2FC_MemView);
  CloseHandle(YUY2FC_hMemMap);
  
  return p;
}

#endif /* YUY2FC_CLIENT_H */
